/*
SimpleFEC: simple forward error correction with small footprint.
*/

// Public core functions
void SimpleFecPutFec(void *data, int len, void *fecData);
void SimpleFecRepairData(void *data, int len, void *fecData);

// Public additional functions
uint16_t SimpleFecGetFecDataLength(int len);
uint8_t CalcXorChecksum(void *data, uint16_t length);

// Internal or special use functions
uint8_t Get5bitBlock(void *baseAddr, uint16_t i);
void Set5bitBlock(void *baseAddr, uint16_t count, uint8_t content);
uint32_t Get26bitBlock(void *baseAddr, uint16_t i);
void Set26bitBlock(void *baseAddr, uint16_t i, uint32_t cont);
uint8_t bitCount(uint32_t data);
uint8_t calcParity(uint32_t data);
int repairData(uint32_t *data, uint8_t par);

