/*
AVR Uart init
Initialization and output function to make printf working.
*/


#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#define BAUD 57600
#include <util/setbaud.h>


int uart_putchar(char c, FILE *stream)
{
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c;
  return 0;
}


void uart_init(void)   
{
    UBRR0H = UBRRH_VALUE;
    UBRR0L = UBRRL_VALUE;

#if USE_2X
    UCSR0A |= (1 << U2X0);
#else
    UCSR0A &= ~(1 << U2X0);
#endif

    UCSR0B |= (1<<RXEN0)|(1<<TXEN0);

    static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, 0, _FDEV_SETUP_RW);
    stdout = &mystdout;
}


